com.io7m.jregions.core.parameterized.areas

## Class PAreasL

- java.lang.Object
- - com.io7m.jregions.core.parameterized.areas.PAreasL

-     public final class PAreasL
      extends Object

  Functions over areas.

  These functions operate using the concepts of minimum-x, maximum-x, minimum-y, and maximum-y edges. It is up to individual applications to assign meaning to these edges such as "left" for minimum-x and "top" for minimum-y.

- - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <S> PAreaL<S>` | `alignCenter(PAreaL<S> outer, PAreaL<S> inner)` Align the area `inner` such that the center of the area is equal to the center of `outer`.
    `static <S> PAreaL<S>` | `alignHorizontallyCenter(PAreaL<S> outer, PAreaL<S> inner)` Deprecated. Use `alignOnXCenter(PAreaL, PAreaL)`
    `static <S> PAreaL<S>` | `alignHorizontallyMaxX(PAreaL<S> outer, PAreaL<S> inner)` Deprecated. Use `alignOnXMaxX(PAreaL, PAreaL)`
    `static <S> PAreaL<S>` | `alignHorizontallyMaxXOffset(PAreaL<S> outer, PAreaL<S> inner, long offset)` Deprecated. Use `alignOnXMaxXOffset(PAreaL, PAreaL, long)`
    `static <S> PAreaL<S>` | `alignHorizontallyMinX(PAreaL<S> outer, PAreaL<S> inner)` Deprecated. Use `alignOnXMinX(PAreaL, PAreaL)`
    `static <S> PAreaL<S>` | `alignHorizontallyMinXOffset(PAreaL<S> outer, PAreaL<S> inner, long offset)` Deprecated. Use `alignOnXMinXOffset(PAreaL, PAreaL, long)`
    `static <S> PAreaL<S>` | `alignMaxYMaxX(PAreaL<S> outer, PAreaL<S> inner)` Equivalent to calling `alignMaxYMaxXOffset(PAreaL, PAreaL, long, long)` with zero offsets.
    `static <S> PAreaL<S>` | `alignMaxYMaxXOffset(PAreaL<S> outer, PAreaL<S> inner, long offset_x, long offset_y)` Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
    `static <S> PAreaL<S>` | `alignMaxYMinX(PAreaL<S> outer, PAreaL<S> inner)` Equivalent to calling `alignMaxYMinXOffset(PAreaL, PAreaL, long, long)` with zero offsets.
    `static <S> PAreaL<S>` | `alignMaxYMinXOffset(PAreaL<S> outer, PAreaL<S> inner, long offset_x, long offset_y)` Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
    `static <S> PAreaL<S>` | `alignMinYMaxX(PAreaL<S> outer, PAreaL<S> inner)` Equivalent to calling `alignMinYMaxXOffset(PAreaL, PAreaL, long, long)` with zero offsets.
    `static <S> PAreaL<S>` | `alignMinYMaxXOffset(PAreaL<S> outer, PAreaL<S> inner, long offset_x, long offset_y)` Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
    `static <S> PAreaL<S>` | `alignMinYMinX(PAreaL<S> outer, PAreaL<S> inner)` Equivalent to calling `alignMinYMinXOffset(PAreaL, PAreaL, long, long)` with zero offsets.
    `static <S> PAreaL<S>` | `alignMinYMinXOffset(PAreaL<S> outer, PAreaL<S> inner, long offset_x, long offset_y)` Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
    `static <S> PAreaL<S>` | `alignOnXCenter(PAreaL<S> outer, PAreaL<S> inner)` Align the area `inner` along the X axis in the center of `outer`.
    `static <S> PAreaL<S>` | `alignOnXMaxX(PAreaL<S> outer, PAreaL<S> inner)` Equivalent to calling `alignOnXMaxXOffset(PAreaL, PAreaL, long)` with a zero offset.
    `static <S> PAreaL<S>` | `alignOnXMaxXOffset(PAreaL<S> outer, PAreaL<S> inner, long offset)` Align the area `inner` along the X axis against the inside maximum-x edge of `outer`.
    `static <S> PAreaL<S>` | `alignOnXMinX(PAreaL<S> outer, PAreaL<S> inner)` Equivalent to calling `alignOnXMinXOffset(PAreaL, PAreaL, long)` with a zero offset.
    `static <S> PAreaL<S>` | `alignOnXMinXOffset(PAreaL<S> outer, PAreaL<S> inner, long offset)` Align the area `inner` along the X axis against the inside minimum-x edge of `outer`.
    `static <S> PAreaL<S>` | `alignOnYCenter(PAreaL<S> outer, PAreaL<S> inner)` Align the area `inner` along the Y axis in the center of `outer`.
    `static <S> PAreaL<S>` | `alignOnYMaxY(PAreaL<S> outer, PAreaL<S> inner)` Equivalent to calling `alignOnYMaxYOffset(PAreaL, PAreaL, long)` with a zero offset.
    `static <S> PAreaL<S>` | `alignOnYMaxYOffset(PAreaL<S> outer, PAreaL<S> inner, long offset)` Align the area `inner` along the Y axis against the inside maximum-y edge of `outer`.
    `static <S> PAreaL<S>` | `alignOnYMinY(PAreaL<S> outer, PAreaL<S> inner)` Equivalent to calling `alignOnYMinYOffset(PAreaL, PAreaL, long)` with a zero offset.
    `static <S> PAreaL<S>` | `alignOnYMinYOffset(PAreaL<S> outer, PAreaL<S> inner, long offset)` Align the area `inner` along the Y axis against the inside minimum-y edge of `outer`.
    `static <S> PAreaL<S>` | `alignVerticallyCenter(PAreaL<S> outer, PAreaL<S> inner)` Deprecated. Use `alignOnYCenter(PAreaL, PAreaL)`
    `static <S> PAreaL<S>` | `alignVerticallyMaxY(PAreaL<S> outer, PAreaL<S> inner)` Deprecated. Use `alignOnYMaxY(PAreaL, PAreaL)`
    `static <S> PAreaL<S>` | `alignVerticallyMaxYOffset(PAreaL<S> outer, PAreaL<S> inner, long offset)` Deprecated. Use `alignOnYMaxYOffset(PAreaL, PAreaL, long)`
    `static <S> PAreaL<S>` | `alignVerticallyMinY(PAreaL<S> outer, PAreaL<S> inner)` Deprecated. Use `alignOnYMinY(PAreaL, PAreaL)`
    `static <S> PAreaL<S>` | `alignVerticallyMinYOffset(PAreaL<S> outer, PAreaL<S> inner, long offset)` Deprecated. Use `alignOnYMinYOffset(PAreaL, PAreaL, long)`
    `static <S,T> PAreaL<T>` | `cast(PAreaL<S> area)` Brand a given area as belonging to a different coordinate space.
    `static <S> PAreaL<S>` | `containing(PAreaL<S> a, PAreaL<S> b)` Construct a area that will contain both `a` and `b`.
    `static <S> boolean` | `contains(PAreaL<S> a, PAreaL<S> b)` Determine whether or not one area contains another.
    `static <S> boolean` | `containsPoint(PAreaL<S> a, long x, long y)` Determine whether or not a area contains a given point.
    `static <S> boolean` | `couldFitInside(PAreaL<S> a, PAreaL<S> b)` Determine whether or not one area could fit inside another.
    `static <S> PAreaL<S>` | `create(long x, long y, long size_x, long size_y)` Create an area of size `size_x` on the X axis and size `size_y` on the Y axis, placing the minimum corner at `(x, y)`.
    `static <S> PAreaL<S>` | `fitBetweenHorizontal(PAreaL<S> fit, PAreaL<S> a, PAreaL<S> b)` Deprecated. Use `fitBetweenOnX(PAreaL, PAreaL, PAreaL)`
    `static <S> PAreaL<S>` | `fitBetweenOnX(PAreaL<S> fit, PAreaL<S> a, PAreaL<S> b)` Attempt to fit `fit` between `a` and `b`, horizontally.
    `static <S> PAreaL<S>` | `fitBetweenOnY(PAreaL<S> fit, PAreaL<S> a, PAreaL<S> b)` Attempt to fit `fit` between `a` and `b`, vertically.
    `static <S> PAreaL<S>` | `fitBetweenVertical(PAreaL<S> fit, PAreaL<S> a, PAreaL<S> b)` Deprecated. Use `fitBetweenOnY(PAreaL, PAreaL, PAreaL)`
    `static <S> PAreaL<S>` | `hollowOut(PAreaL<S> outer, long min_x_offset, long max_x_offset, long min_y_offset, long max_y_offset)` Construct a new area that fits inside `outer` based on the given offsets from each edge.
    `static <S> PAreaL<S>` | `hollowOutEvenly(PAreaL<S> outer, long offset)` Equivalent to calling `hollowOut(PAreaL, long, long, long, long)` with `offset` for all offset parameters.
    `static <S> PAreaL<S>` | `moveAbsolute(PAreaL<S> area, long x, long y)` Move the given area to `(x, y)`.
    `static <S> PAreaL<S>` | `moveRelative(PAreaL<S> area, long x, long y)` Move the given area by `(x, y)`.
    `static <S> PAreaL<S>` | `moveToOrigin(PAreaL<S> area)` Move the given area to `(0, 0)`.
    `static <S> boolean` | `overlaps(PAreaL<S> a, PAreaL<S> b)` Determine whether or not two areas overlap.
    `static <S> PAreaL<S>` | `scaleFromCenter(PAreaL<S> area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaL<S>` | `scaleFromMaxYMaxX(PAreaL<S> area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaL<S>` | `scaleFromMaxYMinX(PAreaL<S> area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaL<S>` | `scaleFromMinYMaxX(PAreaL<S> area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaL<S>` | `scaleFromMinYMinX(PAreaL<S> area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static <S> PAreaL<S>` | `setSizeFromCenter(PAreaL<S> area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> PAreaL<S>` | `setSizeFromMaxYMaxX(PAreaL<S> area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> PAreaL<S>` | `setSizeFromMaxYMinX(PAreaL<S> area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> PAreaL<S>` | `setSizeFromMinYMaxX(PAreaL<S> area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> PAreaL<S>` | `setSizeFromMinYMinX(PAreaL<S> area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static <S> String` | `show(PAreaL<S> area)`
    `static <S> String` | `showToBuilder(PAreaL<S> area, StringBuilder sb)`
    `static <S> PAreaSizeL<S>` | `size(PAreaL<S> area)`
    `static <S> PAreaXSplitL<S,PAreaL<S>>` | `splitAlongParallelToX(PAreaL<S> area, long y)` Split `area` along a line parallel to the X axis placed at `y` units from its own minimum-y edge.
    `static <S> PAreaYSplitL<S,PAreaL<S>>` | `splitAlongParallelToY(PAreaL<S> area, long x)` Split `area` along a line parallel to the Y axis placed at `x` units from its own minimum-x edge.
    `static <S> PAreaXYSplitL<S,PAreaL<S>>` | `splitAlongXY(PAreaL<S> area, long x, long y)` Split `area` along a two axis-aligned perpendicular lines that intercept at `(x, y)`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### create

          public static <S> PAreaL<S> create(long x,
                                             long y,
                                             long size_x,
                                             long size_y)

      Create an area of size `size_x` on the X axis and size `size_y` on the Y axis, placing the minimum corner at `(x, y)`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `x` - The X value of the minimum corner
        `y` - The Y value of the minimum corner
        `size_x` - The size of the area on the X axis
        `size_y` - The size of the area on the Y axis
      Returns:
        An area

    - #### contains

          public static <S> boolean contains(PAreaL<S> a,
                                             PAreaL<S> b)

      Determine whether or not one area contains another.

      Containing is reflexive: `contains(a, a) == true`.

      Containing is transitive: `contains(a, b) → contains(b, c) → contains(a, c)`.

      Containing is not necessarily symmetric.

      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `a` - Area A
        `b` - Area B
      Returns:
        `true` iff `a` contains `b`

    - #### moveRelative

          public static <S> PAreaL<S> moveRelative(PAreaL<S> area,
                                                   long x,
                                                   long y)

      Move the given area by `(x, y)`.
      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x` - The amount to move on the X axis
        `y` - The amount to move on the Y axis
      Returns:
        A moved area

    - #### moveAbsolute

          public static <S> PAreaL<S> moveAbsolute(PAreaL<S> area,
                                                   long x,
                                                   long y)

      Move the given area to `(x, y)`.
      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x` - The position to which to move on the X axis
        `y` - The position to which to move on the Y axis
      Returns:
        A moved area

    - #### moveToOrigin

          public static <S> PAreaL<S> moveToOrigin(PAreaL<S> area)

      Move the given area to `(0, 0)`.
      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
      Returns:
        A moved area

    - #### cast

          public static <S,T> PAreaL<T> cast(PAreaL<S> area)

      Brand a given area as belonging to a different coordinate space. Mixing up coordinate spaces is a common source of difficult-to-locate bugs. Use at your own risk.
      Type Parameters:
        `S` - The starting coordinate space
        `T` - The resulting coordinate space
      Parameters:
        `area` - An area
      Returns:
        `area`

    - #### alignHorizontallyCenter

          @Deprecated
          public static <S> PAreaL<S> alignHorizontallyCenter(PAreaL<S> outer,
                                                                          PAreaL<S> inner)

      Deprecated. Use `alignOnXCenter(PAreaL, PAreaL)`
      Align the area `inner` horizontally in the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMinX

          @Deprecated
          public static <S> PAreaL<S> alignHorizontallyMinX(PAreaL<S> outer,
                                                                        PAreaL<S> inner)

      Deprecated. Use `alignOnXMinX(PAreaL, PAreaL)`
      Equivalent to calling `alignHorizontallyMinXOffset(PAreaL, PAreaL, long)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMinXOffset

          @Deprecated
          public static <S> PAreaL<S> alignHorizontallyMinXOffset(PAreaL<S> outer,
                                                                              PAreaL<S> inner,
                                                                              long offset)

      Deprecated. Use `alignOnXMinXOffset(PAreaL, PAreaL, long)`
      Align the area `inner` horizontally against the inside minimum-x edge of `outer`. The area will be at least `offset` units from the minimum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignHorizontallyMaxX

          @Deprecated
          public static <S> PAreaL<S> alignHorizontallyMaxX(PAreaL<S> outer,
                                                                        PAreaL<S> inner)

      Deprecated. Use `alignOnXMaxX(PAreaL, PAreaL)`
      Equivalent to calling `alignHorizontallyMaxXOffset(PAreaL, PAreaL, long)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMaxXOffset

          @Deprecated
          public static <S> PAreaL<S> alignHorizontallyMaxXOffset(PAreaL<S> outer,
                                                                              PAreaL<S> inner,
                                                                              long offset)

      Deprecated. Use `alignOnXMaxXOffset(PAreaL, PAreaL, long)`
      Align the area `inner` horizontally against the inside maximum-x edge of `outer`. The area will be at least `offset` units from the maximum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyMinY

          @Deprecated
          public static <S> PAreaL<S> alignVerticallyMinY(PAreaL<S> outer,
                                                                      PAreaL<S> inner)

      Deprecated. Use `alignOnYMinY(PAreaL, PAreaL)`
      Equivalent to calling `alignVerticallyMinYOffset(PAreaL, PAreaL, long)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignVerticallyMinYOffset

          @Deprecated
          public static <S> PAreaL<S> alignVerticallyMinYOffset(PAreaL<S> outer,
                                                                            PAreaL<S> inner,
                                                                            long offset)

      Deprecated. Use `alignOnYMinYOffset(PAreaL, PAreaL, long)`
      Align the area `inner` vertically against the inside minimum-y edge of `outer`. The area will be at least `offset` units from the minimum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyMaxY

          @Deprecated
          public static <S> PAreaL<S> alignVerticallyMaxY(PAreaL<S> outer,
                                                                      PAreaL<S> inner)

      Deprecated. Use `alignOnYMaxY(PAreaL, PAreaL)`
      Equivalent to calling `alignVerticallyMaxYOffset(PAreaL, PAreaL, long)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignVerticallyMaxYOffset

          @Deprecated
          public static <S> PAreaL<S> alignVerticallyMaxYOffset(PAreaL<S> outer,
                                                                            PAreaL<S> inner,
                                                                            long offset)

      Deprecated. Use `alignOnYMaxYOffset(PAreaL, PAreaL, long)`
      Align the area `inner` vertically against the inside maximum-y edge of `outer`. The area will be at least `offset` units from the maximum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyCenter

          @Deprecated
          public static <S> PAreaL<S> alignVerticallyCenter(PAreaL<S> outer,
                                                                        PAreaL<S> inner)

      Deprecated. Use `alignOnYCenter(PAreaL, PAreaL)`
      Align the area `inner` vertically in the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignOnXCenter

          public static <S> PAreaL<S> alignOnXCenter(PAreaL<S> outer,
                                                     PAreaL<S> inner)

      Align the area `inner` along the X axis in the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMinX

          public static <S> PAreaL<S> alignOnXMinX(PAreaL<S> outer,
                                                   PAreaL<S> inner)

      Equivalent to calling `alignOnXMinXOffset(PAreaL, PAreaL, long)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMinXOffset

          public static <S> PAreaL<S> alignOnXMinXOffset(PAreaL<S> outer,
                                                         PAreaL<S> inner,
                                                         long offset)

      Align the area `inner` along the X axis against the inside minimum-x edge of `outer`. The area will be at least `offset` units from the minimum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMaxX

          public static <S> PAreaL<S> alignOnXMaxX(PAreaL<S> outer,
                                                   PAreaL<S> inner)

      Equivalent to calling `alignOnXMaxXOffset(PAreaL, PAreaL, long)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMaxXOffset

          public static <S> PAreaL<S> alignOnXMaxXOffset(PAreaL<S> outer,
                                                         PAreaL<S> inner,
                                                         long offset)

      Align the area `inner` along the X axis against the inside maximum-x edge of `outer`. The area will be at least `offset` units from the maximum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMinY

          public static <S> PAreaL<S> alignOnYMinY(PAreaL<S> outer,
                                                   PAreaL<S> inner)

      Equivalent to calling `alignOnYMinYOffset(PAreaL, PAreaL, long)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMinYOffset

          public static <S> PAreaL<S> alignOnYMinYOffset(PAreaL<S> outer,
                                                         PAreaL<S> inner,
                                                         long offset)

      Align the area `inner` along the Y axis against the inside minimum-y edge of `outer`. The area will be at least `offset` units from the minimum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMaxY

          public static <S> PAreaL<S> alignOnYMaxY(PAreaL<S> outer,
                                                   PAreaL<S> inner)

      Equivalent to calling `alignOnYMaxYOffset(PAreaL, PAreaL, long)` with a zero offset.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMaxYOffset

          public static <S> PAreaL<S> alignOnYMaxYOffset(PAreaL<S> outer,
                                                         PAreaL<S> inner,
                                                         long offset)

      Align the area `inner` along the Y axis against the inside maximum-y edge of `outer`. The area will be at least `offset` units from the maximum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYCenter

          public static <S> PAreaL<S> alignOnYCenter(PAreaL<S> outer,
                                                     PAreaL<S> inner)

      Align the area `inner` along the Y axis in the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignMinYMinX

          public static <S> PAreaL<S> alignMinYMinX(PAreaL<S> outer,
                                                    PAreaL<S> inner)

      Equivalent to calling `alignMinYMinXOffset(PAreaL, PAreaL, long, long)` with zero offsets.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMinXOffset

          public static <S> PAreaL<S> alignMinYMinXOffset(PAreaL<S> outer,
                                                          PAreaL<S> inner,
                                                          long offset_x,
                                                          long offset_y)

      Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the minimum-x edge
        `offset_y` - The offset from the minimum-y edge
      Returns:
        An aligned area

    - #### alignMinYMaxX

          public static <S> PAreaL<S> alignMinYMaxX(PAreaL<S> outer,
                                                    PAreaL<S> inner)

      Equivalent to calling `alignMinYMaxXOffset(PAreaL, PAreaL, long, long)` with zero offsets.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMaxXOffset

          public static <S> PAreaL<S> alignMinYMaxXOffset(PAreaL<S> outer,
                                                          PAreaL<S> inner,
                                                          long offset_x,
                                                          long offset_y)

      Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the maximum-x edge
        `offset_y` - The offset from the minimum-y edge
      Returns:
        An aligned area

    - #### alignMaxYMinX

          public static <S> PAreaL<S> alignMaxYMinX(PAreaL<S> outer,
                                                    PAreaL<S> inner)

      Equivalent to calling `alignMaxYMinXOffset(PAreaL, PAreaL, long, long)` with zero offsets.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMaxYMinXOffset

          public static <S> PAreaL<S> alignMaxYMinXOffset(PAreaL<S> outer,
                                                          PAreaL<S> inner,
                                                          long offset_x,
                                                          long offset_y)

      Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the minimum-x edge
        `offset_y` - The offset from the maximum-y edge
      Returns:
        An aligned area

    - #### alignMaxYMaxX

          public static <S> PAreaL<S> alignMaxYMaxX(PAreaL<S> outer,
                                                    PAreaL<S> inner)

      Equivalent to calling `alignMaxYMaxXOffset(PAreaL, PAreaL, long, long)` with zero offsets.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMaxYMaxXOffset

          public static <S> PAreaL<S> alignMaxYMaxXOffset(PAreaL<S> outer,
                                                          PAreaL<S> inner,
                                                          long offset_x,
                                                          long offset_y)

      Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the maximum-x edge
        `offset_y` - The offset from the maximum-y edge
      Returns:
        An aligned area

    - #### alignCenter

          public static <S> PAreaL<S> alignCenter(PAreaL<S> outer,
                                                  PAreaL<S> inner)

      Align the area `inner` such that the center of the area is equal to the center of `outer`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### hollowOut

          public static <S> PAreaL<S> hollowOut(PAreaL<S> outer,
                                                long min_x_offset,
                                                long max_x_offset,
                                                long min_y_offset,
                                                long max_y_offset)

      Construct a new area that fits inside `outer` based on the given offsets from each edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The containing area
        `min_x_offset` - The offset from the minimum-x edge (must be non-negative)
        `max_x_offset` - The offset from the maximum-x edge (must be non-negative)
        `min_y_offset` - The offset from the minimum-y edge (must be non-negative)
        `max_y_offset` - The offset from the maximum-y edge (must be non-negative)
      Returns:
        A new area

    - #### hollowOutEvenly

          public static <S> PAreaL<S> hollowOutEvenly(PAreaL<S> outer,
                                                      long offset)

      Equivalent to calling `hollowOut(PAreaL, long, long, long, long)` with `offset` for all offset parameters.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `outer` - The containing area
        `offset` - The offset from each edge (must be non-negative)
      Returns:
        A new area

    - #### setSizeFromCenter

          public static <S> PAreaL<S> setSizeFromCenter(PAreaL<S> area,
                                                        long sizeX,
                                                        long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized from its own center.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMinYMinX

          public static <S> PAreaL<S> setSizeFromMinYMinX(PAreaL<S> area,
                                                          long sizeX,
                                                          long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its minimum-y-minimum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMinYMaxX

          public static <S> PAreaL<S> setSizeFromMinYMaxX(PAreaL<S> area,
                                                          long sizeX,
                                                          long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its minimum-y-maximum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMaxYMaxX

          public static <S> PAreaL<S> setSizeFromMaxYMaxX(PAreaL<S> area,
                                                          long sizeX,
                                                          long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its maximum-y-maximum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMaxYMinX

          public static <S> PAreaL<S> setSizeFromMaxYMinX(PAreaL<S> area,
                                                          long sizeX,
                                                          long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its maximum-y-minimum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### scaleFromMinYMinX

          public static <S> PAreaL<S> scaleFromMinYMinX(PAreaL<S> area,
                                                        long x_diff,
                                                        long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its minimum-y-minimum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMinYMaxX

          public static <S> PAreaL<S> scaleFromMinYMaxX(PAreaL<S> area,
                                                        long x_diff,
                                                        long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its minimum-y-maximum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMaxYMinX

          public static <S> PAreaL<S> scaleFromMaxYMinX(PAreaL<S> area,
                                                        long x_diff,
                                                        long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its maximum-y-minimum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMaxYMaxX

          public static <S> PAreaL<S> scaleFromMaxYMaxX(PAreaL<S> area,
                                                        long x_diff,
                                                        long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its maximum-y-maximum-x corner.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromCenter

          public static <S> PAreaL<S> scaleFromCenter(PAreaL<S> area,
                                                      long x_diff,
                                                      long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized from its own center.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### overlaps

          public static <S> boolean overlaps(PAreaL<S> a,
                                             PAreaL<S> b)

      Determine whether or not two areas overlap.

      Overlapping is reflexive: `overlaps(a, a) == true`.

      Overlapping is symmetric: `overlaps(a, b) == overlaps(b, a)`.

      Overlapping is not necessarily transitive.

      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        `true` iff `a` overlaps `b`

    - #### couldFitInside

          public static <S> boolean couldFitInside(PAreaL<S> a,
                                                   PAreaL<S> b)

      Determine whether or not one area could fit inside another.

      Fitting is reflexive: `couldFitInside(a, a) == true`.

      Fitting is transitive: `couldFitInside(a, b) → couldFitInside(b, c) → couldFitInside(a, c)`.

      Fitting is not necessarily symmetric.

      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        `true` iff `a` could fit inside `b`

    - #### containing

          public static <S> PAreaL<S> containing(PAreaL<S> a,
                                                 PAreaL<S> b)

      Construct a area that will contain both `a` and `b`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        An area containing `a` and `b`

    - #### containsPoint

          public static <S> boolean containsPoint(PAreaL<S> a,
                                                  long x,
                                                  long y)

      Determine whether or not a area contains a given point.

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `a` - An area
        `x` - The X coordinate of the point
        `y` - The Y coordinate of the point
      Returns:
        `true` iff `a` contains `(x, y)`

    - #### fitBetweenHorizontal

          @Deprecated
          public static <S> PAreaL<S> fitBetweenHorizontal(PAreaL<S> fit,
                                                                       PAreaL<S> a,
                                                                       PAreaL<S> b)

      Deprecated. Use `fitBetweenOnX(PAreaL, PAreaL, PAreaL)`
      Attempt to fit `fit` between `a` and `b`, horizontally.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenVertical

          @Deprecated
          public static <S> PAreaL<S> fitBetweenVertical(PAreaL<S> fit,
                                                                     PAreaL<S> a,
                                                                     PAreaL<S> b)

      Deprecated. Use `fitBetweenOnY(PAreaL, PAreaL, PAreaL)`
      Attempt to fit `fit` between `a` and `b`, vertically.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenOnX

          public static <S> PAreaL<S> fitBetweenOnX(PAreaL<S> fit,
                                                    PAreaL<S> a,
                                                    PAreaL<S> b)

      Attempt to fit `fit` between `a` and `b`, horizontally.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenOnY

          public static <S> PAreaL<S> fitBetweenOnY(PAreaL<S> fit,
                                                    PAreaL<S> a,
                                                    PAreaL<S> b)

      Attempt to fit `fit` between `a` and `b`, vertically.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### splitAlongParallelToX

          public static <S> PAreaXSplitL<S,PAreaL<S>> splitAlongParallelToX(PAreaL<S> area,
                                                                            long y)

      Split `area` along a line parallel to the X axis placed at `y` units from its own minimum-y edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `area` - The area to be split
        `y` - The relative Y coordinate of the splitting edge
      Returns:
        A pair of areas

    - #### splitAlongParallelToY

          public static <S> PAreaYSplitL<S,PAreaL<S>> splitAlongParallelToY(PAreaL<S> area,
                                                                            long x)

      Split `area` along a line parallel to the Y axis placed at `x` units from its own minimum-x edge.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `area` - The area to be split
        `x` - The relative X coordinate of the splitting edge
      Returns:
        A pair of areas

    - #### splitAlongXY

          public static <S> PAreaXYSplitL<S,PAreaL<S>> splitAlongXY(PAreaL<S> area,
                                                                    long x,
                                                                    long y)

      Split `area` along a two axis-aligned perpendicular lines that intercept at `(x, y)`.
      Type Parameters:
        `S` - The coordinate space of the areas
      Parameters:
        `area` - The area to be split
        `x` - The relative X coordinate of the splitting edge
        `y` - The relative Y coordinate of the splitting edge
      Returns:
        The four resulting quadrants
      Since:
        1.1.0

    - #### show

          public static <S> String show(PAreaL<S> area)

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
      Returns:
        A terse string describing the position and size of the area

    - #### size

          public static <S> PAreaSizeL<S> size(PAreaL<S> area)

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
      Returns:
        The size of the area

    - #### showToBuilder

          public static <S> String showToBuilder(PAreaL<S> area,
                                                 StringBuilder sb)

      Type Parameters:
        `S` - The coordinate space of the area
      Parameters:
        `area` - The area
        `sb` - A string builder
      Returns:
        A terse string describing the position and size of the area

Copyright © 2017 <code@io7m.com> http://io7m.com